'\"
'\" Generated from file 'config.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2006 Georg Lehner <jorge@magma.com.ni
'\"
'\" -*- tcl -*- doctool manpage
.so man.macros
.TH "config" n 0.1  "options managment"
.BS
.SH "NAME"
config \- onfiguration and preferences managment
.SH "SYNOPSIS"
package require \fBTcl  8.2\fR
.sp
package require \fBconfig  ?0.1?\fR
.sp
\fB::config::add_option\fR \fIoptionset\fR \fIname\fR \fIshort_description\fR ?options?
.sp
\fB::config::add_file\fR \fIoptionset\fR ?\fIparser\fR? ?\fI-tag tag\fR? ?\fIfilename ..\fR?
.sp
\fB::config::get_config\fR \fIoptionset\fR ?\fIparser\fR? ?\fIusage\fR? ?\fIenvname\fR? ?\fIshortcut\fR?
.sp
\fB::config::env_getoptions\fR \fIoptionset\fR
.sp
\fB::config::parse_file\fR \fIoptionset\fR ?\fItag\fR?
.sp
\fB::config::tcl_parse_file\fR \fIoptionset\fR \fIfilename\fR
.sp
\fB::config::cmdline_getoptions\fR \fIoptionset\fR \fIargv\fR ?\fIusage\fR?
.sp
\fB::config::optionset\fR \fIoptionset\fR ?\fIprocessor\fR?
.sp
.BE
.SH "DESCRIPTION"
.PP
The \fBconfig\fR package provides flexible options managment.
.PP
A programms configuration or user preferences can be stored in
\fIoptionset\fRs, which can be set from configuration files, the
environment or from the commandline.
.SH "OVERVIEW"
.PP
\fIoption\fRs are elements of \fIoptionset\fRs, their value can be set from
several \fIsource\fRs.
An \fIoptionset\fR holds information about \fIsource\fRs, default
values, descriptions, shortcuts, configuration file locations of a
range of \fIoptions\fR
.PP
In the end, an \fIoptionset\fR is a Tcl array which can be
manipulated as needed by the program.
.PP
Configuration files can be specified explicitely, else an internal
heuristic can be used to determine posible locations and names of
configuration files.  Any number of configuration files can be
specified for an \fIoptionset\fR.
The format of each configuration file can be defined individually.
Actually (safe) Tcl is the default and actually the only option.
.PP
Commandline parsing is also configurable, beeing the \fBcmdline\fR
package the default and actually only option.
.PP
Note that the the \fBcmdline\fR package is not required, if
commandline parseing is not used.
.PP
Although \fBconfig\fR is designed with extensibility in mind, its
main purpose is to simplify option handling.  The default way to
invoke option processing is just to call \fB::config::get_config\fR.
.PP
The following sequence is then invoked to process options:
.IP [1]
determine location of configuration files in the following order:
.RS
.IP \(bu from program defaults
.IP \(bu from the environment
.IP \(bu from the commandline
.RE
.IP [2]
The following stages are processed to determine the value of a all
other options:
.RS
.IP \(bu program default
.IP \(bu system
.IP \(bu user
.IP \(bu environment
.IP \(bu commandline
.RE
if a value is obtained from a later stage, it overrides any data
collected from an earlier stage:
.SH "COMMANDS"
.SS "VARIABLES"
.TP
\fB::config::optionsets\fR  list of defined optionsets
.TP
\fB::config::version\fR  version of the config package
.SS "Defining Optionsets"
.TP
\fB::config::add_option\fR \fIoptionset\fR \fIname\fR \fIshort_description\fR ?options?
Define an optionset. posible ?options? are:
.RS
.TP
\fB-secret\fR don't show the option to the user
.TP
\fB-optional\fR this option may have an argument
.TP
\fB-default\fR defaultvalue set the default value
.TP
\fB-shortcut\fR shortcut
the first letter of \fBshortcut\fR is used as sinlge letter option
name for the option
.TP
\fB-env\fR envname
\fBenvname\fR is the name of the environment variable used to set
the option
.RE
.sp
.TP
\fB::config::add_file\fR \fIoptionset\fR ?\fIparser\fR? ?\fI-tag tag\fR? ?\fIfilename ..\fR?
Register a configuration file to be parsed with \fIparser\fR. Eventuall add
a \fItag\fR to distinguish configuration file setup. The list of
files: \fIfilename ..\fR will be searched in order, the first file matched is
used.
.sp
If the list of files is empty, search in several places with
predefined names derived from \fBargv0\fR and \fItag\fR.  If \fItag\fR
is not specified set it to \fB$argv0\fR.  If \fIparser\fR is not
specified set it to \fBtcl\fR
.SS "Get the options set"
.TP
\fB::config::get_config\fR \fIoptionset\fR ?\fIparser\fR? ?\fIusage\fR? ?\fIenvname\fR? ?\fIshortcut\fR?
parse options from environment, config files and the commandline of
a program.
.RS
.TP
\fIusage\fR string  modfiy the usage message of cmdline
.TP
\fIshortcut\fR string  modify the shortcut for the configfile option, default 'c'
.TP
\fIenvname\fR token  modify the environment variable used to look up the
configfile, default CONFIG
.TP
\fIparser\fR token  modify the parser used to parse the configfile, default tcl
.RE
.TP
\fB::config::env_getoptions\fR \fIoptionset\fR
set options from environment variables
.TP
\fB::config::parse_file\fR \fIoptionset\fR ?\fItag\fR?
(eventually) set options by parsing the configuration file specified
by \fItag\fR, or the default configuration file if \fItag\fR is not specified
.TP
\fB::config::tcl_parse_file\fR \fIoptionset\fR \fIfilename\fR
parse \fIfilename\fR in a safe interpreter and set \fIoptioneset\fR with
variables defined there whose name is in \fB$optionset(options)\fR.
.TP
\fB::config::cmdline_getoptions\fR \fIoptionset\fR \fIargv\fR ?\fIusage\fR?
parse the argumentstring in the variable named \fIargv\fR into the optionset
with the \fBcmdline\fR parser.
.TP
\fB::config::optionset\fR \fIoptionset\fR ?\fIprocessor\fR?
.RS
.TP
\fIoptionset\fR token name of an array holding optionset definition
.TP
\fIprocessor\fR token name of the processor to use, by default
\fBcmdline\fR
.RE
The \fIoptionset\fR is converted into a form usable by the \fIprocessor\fR and
then \fBreturn\fR'ed
.SH "Terms and Concepts"
.TP
option
An option is some data that determines certain behavior of a program
.TP
configuration
is an option that is determined at programm start and is not to be
changed during the runtime of a programm.
.TP
preference
is an option that is initialized during program start, may be altered
during the runtime of a program and may be saved for future
invocations of the program.
.SS "SCOPE"
.TP
system (wide setting)
Is data for options, that is given for invocations under any of the
systems users.
.TP
user (setting)
Is data for options, that is specific for invocation of a specific
user.
.TP
programm (default setting)
is data for options, that is predefined for invocation of the program
on any system.
.SS "SOURCES"
configuration options can be set from:
.IP \(bu files
.IP \(bu environment variables
.IP \(bu commandline options and arguments
preferences can also be set from program input (user interaction)
.SS "OPTIONSETs"
In the following * means not supported by \fBcmdline\fR package
.PP
An optionset is an array, describing options.  The optionset is first
defined, and can then be manipulated by searching the environment, the
commandline, several configuration or preferences files and user input
during the runtime of the program.
.PP
In the following list of reserved indexes 'option' containes the name
of an option
.TP
\fB($option)\fR
holds the value of the option after option processing
.TP
\fB(options)\fR list of option names, auto generated by \fBadd_option\fR
.TP
\fB(shortcuts)\fR list of the respective shortcuts
No check is made to garantee unique shortcuts
.TP
\fB($option,shortcut)\fR token
.RS
.TP
\fBstring\fR  the letter to use is the first letter of string
.TP
\fBtrue or unset\fR  use first letter of longname
.TP
\fBfalse\fR  do not define a short option *
.RE
.TP
\fB($shortcut,option)\fR option
this reverse index of shortcuts to optionname is created during
parsing of the options, put deleted afterwards
.TP
\fB($option,secret)\fR flag
.RS
.TP
\fBtrue\fR  do not show the option to the user
.TP
\fBfalse or unset\fR  show in usage messages, etc.
when using \fBcmdline\fR this is made a boolean option
.RE
.TP
\fB($option,default)\fR defaultvalue
.RS
.TP
\fBnot set\fR  option is a boolean
.TP
\fBelse\fR  value to give the option if not defined elsewhere
.RE
.TP
\fB($options,optional)\fR flag
only taken into account if defaultvalue exists
.RS
.TP
\fBtrue\fR  the option may be specified without an argument
in which case it is set to the \fIdefaultvalue\fR *
.TP
\fBnot\fR existent or false  an argument to the option must be given
.RE
.TP
\fB($option,description)\fR long description *
.TP
\fB($option,short)\fR (less then) one line description
this index is \fIrequired\fR
.TP
\fB($option,env)\fR name
name of the asociated environment variable
.TP
\fB(tags)\fR  list of tags, each describing a configuration fileset
.TP
\fB($tag,files)\fR list of possible configuration files
.TP
\fB($tag,parser)\fR parser used for this configuration file
.TP
\fB($tag,filename)\fR first filename out of \fB($tag,files)\fR which exists
If no tag is specified:
.TP
\fB(files)\fR list of files
.TP
\fB(filename)\fR first filename out of (files)
.TP
\fB(parser)\fR parser to use for (filename)
.SH "EXAMPLES"
.nf
package require config
::config::add_options config <name> <description> \\
                             -default <value> -env <NAME>
..
::config::get_config config
.fi
This will set \fB$config(<name>)\fR to one of:
.IP \(bu
<value>
.IP \(bu
the value of the variable <name> set in a tcl config file that
can be placed at various system wide or user specific places
.IP \(bu
the value of the environment variable <NAME>
.IP \(bu
the value of the -<n> switch on the commandline, where <n> is the
first letter of <name>
Later items in the list precede earlier items.
.SH "SEE ALSO"
.IP \(bu
\fIAuthor's Webpage about \fBconfig\fR\fR [http://www.magma.com.ni/moin/TclConfig]
.IP \(bu
\fI\fBcmdline\fR package\fR [http://tcllib.sourceforge.net/doc/cmdline.html]
.IP \(bu
\fITcler's Wiki about configuration file handling\fR [http://wiki.tcl.tk/2438]
.SH "KEYWORDS"
argument processing, cmdline processing, configuration files
.SH "COPYRIGHT"
.nf
Copyright (c) 2006 Georg Lehner <jorge@magma.com.ni
.fi